<?php
/**
 * @package CG Popup Module
 * @version 1.2.0: 2020 October
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2020 ConseilGouz. All Rights Reserved.
 * @author ConseilGouz 
 *
 * Compatible Joomla 3.8 and 4.0 alpha 2
 */
defined('_JEXEC') or die;

JHtml::_('jquery.framework'); // 1.1.10 : make sure jQuery is loaded

$document = JFactory::getDocument();
$modulefield	= ''.JURI::base(true).'/modules/'.$module->module;
// Get module sfx class
$moduleclass_sfx = htmlspecialchars($params->get('moduleclass_sfx'));

$layout = 'default';
$tag_id = 'sp-popup-'.$module->id;
$detail = $params->get("detail");
$width = $detail->width_popup;
$margin = str_replace(',',' ',$detail->margin_popup);
$opacity = $detail->opacity_popup;
$color = $detail->color_popup;
$document->addStyleDeclaration($params->get('css_popup'));
$document->addScript($modulefield . '/assets/js/velocity.min.js');
$document->addScript($modulefield. '/assets/js/velocity.ui.min.js');
$document->addScript($modulefield . '/assets/js/cg_popup.js');

$delay = '0';
if ($params->get('trigger','none') == 'delay') {
	$delay = $params->get('sp-delay','0') ;
}
$document->addScriptOptions('cg_popup_'.$module->id, 
	array('id' => $module->id,'current' => JURI::current(),'title_button_popup' => $params->get('title_button_popup','')
		,'speffect' => $params->get('sp-effect','fadeIn'),'delay' => $delay,'spscroll' => $params->get('sp-scroll','0'), 'spscrollmax' => $params->get('sp-scroll-max','9999')
		,'trigger' => $params->get('trigger','none'),'duration' => $params->get('cookie_duration','0'),'date_popup' => $params->get('update_date_popup','') 
		, 'width' => $width, 'background' => $color, 'margin' => $margin, 'opacity' => $opacity,'pos' => $params->get('position')->vertical_popup
		, 'title_button_first' =>  $params->get('title_button_first','0') )
	);
require JModuleHelper::getLayoutPath($module->module, $layout);
?>